/* yasep/GNL/nodes.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created jeu. mai  3 02:16:49 CEST 2012 by whygee@f-cpu.org
version sam. mai  5 06:50:16 CEST 2012

This file contains the "default library" of GNL nodes.
certain parts should be moved to the instruction set files.
*/

lib_nodes={
  misc:[
[
  [],
  [],
  "#CBC",
  "NOP"
],
[
  [{number:"4h"}],
  [],
  "#BCB",
  "CRIT"
],
[
  [{number:"1234h"}],
  [{port:"output1"}],
  "#BCB",
  "const"
],
[
  [{port:"addr"}],
  [{port:"data"}],
  "#BBC",
  "ReadMem"
],
[
  [{port:"data"}, {port:"addr"} ],
  [],
  "#CBB",
  "SR_Put"
],
[
  [{port:"addr"}],
  [{port:"data"}],
  "#BCC",
  "SR_Get"
],
[
  [{port:"data"}, {port:"addr"} ],
  [],
  "#CCB",
  "WriteMem"
],
[
  [{port:"input1"},  {port:"input2"} ],
  [{port:"output1"}, {port:"output2"}, {port:"output3"} ],
  "#F99",
  "stupid_example"
]
],

  arith:[
   [  [{port:"a"   }, {port:"b"    } ],  [{port:"sum" }],  "#F99",  "ADD" ],
   [  [{port:"plus"}, {port:"minus"} ],  [{port:"diff"}],  "#F99",  "SUB" ],
   [  [{port:"plus"}, {port:"minus"} ],  [],               "#F99",  "CMPU"],
   [  [{port:"plus"}, {port:"minus"} ],  [],               "#F99",  "CMPS"],
   [  [{port:"a"   }, {port:"b"    } ],  [{port:"diff"}],  "#F99",  "UMIN"],
   [  [{port:"a"   }, {port:"b"    } ],  [{port:"diff"}],  "#F99",  "UMAX"],
   [  [{port:"a"   }, {port:"b"    } ],  [{port:"diff"}],  "#F99",  "SMIN"],
   [  [{port:"a"   }, {port:"b"    } ],  [{port:"diff"}],  "#F99",  "SMAX"]
],


  bool:[
   [  [{port:"a"},  {port:"b"} ],  [{port:"x"}],  "#F99",  "AND" ],
   [  [{port:"a"},  {port:"b"} ],  [{port:"x"}],  "#F99",  "OR"  ],
   [  [{port:"a"},  {port:"b"} ],  [{port:"x"}],  "#F99",  "XOR" ],
   [  [{port:"a_"}, {port:"b"} ],  [{port:"x"}],  "#F99",  "ANDN"],
   [  [{port:"a_"}, {port:"b"} ],  [{port:"x"}],  "#F99",  "ORN" ],
   [  [{port:"a_"}, {port:"b"} ],  [{port:"x"}],  "#F99",  "XORN"],
   [  [{port:"a"},  {port:"b"} ],  [{port:"x_"}], "#F99",  "NAND"],
   [  [{port:"a"},  {port:"b"} ],  [{port:"x_"}], "#F99",  "NOR" ]
],

  conditions:[
   [  [{port:"val"},  {port:"yes"},  {port:"no"} ],  [{port:"x"}],  "#F9F",  "Zero" ],
   [  [{port:"val"},  {port:"yes"},  {port:"no"} ],  [{port:"x"}],  "#F9F",  "Not Zero" ],
   [  [{port:"val"},  {port:"yes"},  {port:"no"} ],  [{port:"x"}],  "#F9F",  "LSB=1" ],
   [  [{port:"val"},  {port:"yes"},  {port:"no"} ],  [{port:"x"}],  "#F9F",  "LSB=0" ],
   [  [{port:"val"},  {port:"yes"},  {port:"no"} ],  [{port:"x"}],  "#F9F",  "MSB=1" ],
   [  [{port:"val"},  {port:"yes"},  {port:"no"} ],  [{port:"x"}],  "#F9F",  "MSB=0" ],
   [  [{number:"4h"},  {port:"val"},  {port:"yes"},  {port:"no"} ],  [{port:"x"}],  "#F9F",  "bit=1" ],
   [  [{number:"3h"},  {port:"val"},  {port:"yes"},  {port:"no"} ],  [{port:"x"}],  "#F9F",  "bit=0" ]
]

};

/*
// reverse lookup :
default_nodes_names={};
for (var i in default_nodes) {
  var j=default_nodes[i];
  default_nodes_names[j[3]]=i;
}
*/