/* yasep/tool/yasim.js
 created ven. oct.  5 06:38:36 CEST 2012 by whygee@f-cpu.org
 lun. oct.  8 21:49:12 CEST 2012 : renamed from simul.js
 sam. oct. 13 06:14:28 CEST 2012 moved adjustHeight to its own files
*/

/*
function tagFocus(){
  ygwm.focus_window(null,this.win);
  return false;
}

//<font color=\"red\" size=\"+2\"><b> \u27A1";
//
// \u1405  \u2192  \u21D2  \u22B3  \u21F0  \u2326  \u232B  \u261B"
//      +" \u2794 \u2799 \u279B \u279C \u279D \u279E \u279F \u27A0 \u27A1 \u27A2"
//      +" \u27A4  \u27A8 \u2907 \uFFEB";
//x1405 ᐅ
//x2192 →
//x21D2 ⇒ 
//x22B3 ⊳
//x21F0 ⇰
//x2326 ⌦
//x232B ⌫
//x261B ☛ 
//x2790 ➔ ➙ ➛ ➜ ➝ ➞ ➟
//x27A4 ➤
//x27A8 ➨
//x27A0 ➠ ➡ ➢ ➣ ➤ ➥ ➦ ➧ ➨ ➩ ➪ ➫ ➬ ➭ ➮ ➯
//x27B0 ➱ ➲ ➳ ➵ ➶ ➷ ➸ ➹ ➺ ➻ ➼ ➽ ➾
//x2907 ⤇
//x2900 and on...
//x2B00 ...
//xFFEB  ￫

Drag&drop du curseur pour faire avancer le programme ?
*/



////////////////////////////////////////////////////////////

init_obj.push(sim={

  simCount:1,

////////////////////////////////////////////////////////////
/// Eye candy

  showhideNext:function() {
    var a=this.firstChild,
        b=this.parentNode.nextSibling.style,
        c=(a.nodeName=="SPAN");
    if (b.display=="none"){
      c && (a.innerHTML="\u25BD");
      b.display="block";
    } else {
      c && (a.innerHTML="\u25B7");
      b.display="none";
    }
  },

///////////// floating cursor :
  create_cursor: function(col,cont,omd,w){
    var c=dcE("DIV");
    c.win=w;
    c.className="tag";
    c.style.color=col;
    c.innerHTML=cont+"<font size=\"+2\"><b>\u27A1</b></font>";
    c.onmousedown=omd;
    return c;
  },


///////////// Finite State Machine :
  states:["INIT", "STEP", "RUN", "STOP", "HALT", "FAULT"],
  // The actual state is stored in win.state

  showState: function(w) {
    redraw(function(){
      w.shortmsg("&nbsp;Status:&nbsp;<i>"+sim.states[w.state]+"</i>");
    });
/*      d.innerHTML+=" &nbsp;&nbsp;Status:&nbsp;";
      d.appendChild(win.StatId=dcE("SPAN"));
      win.StatId.style.fontStyle="italic";
    w.StatId.innerHTML=sim.states[w.state];*/
  },

  resetState: function(e,t) {
    var i, w=parentWin(t||this);

    if (!t)
      sim.stop(w);  // Stop if button pressed.

    w.cycle_id.innerHTML
      =w.cycle
      =w.state
      =w.address
      =w.result
      =0;
    sim.showState(w);

    for (i in w.regs){
      w.regs[i]=null;
      w.regs_id[i].innerHTML="u";
      w.regs_id[i].id=""; //bgcolor
    }

    sim.resetTrace(w);

    // Clear history

    sim.regWrite(w,0,0); // PC=0
    w.Carry
   =w.Zero
   =0;
    w.Carry_id.checked
   =w.Zero_id.checked
   =w.BPstop // No fault or breakpoint
   =false;

    sim.flushChanges(0,w);

    // read instruction memory and disassemble
    sim.instrLoad(w);
    sim.updateASM(w);
  },

  flushChanges: function(e,t) {
    var i, w=parentWin(t||this);
    for (i in w.regs)
      w.regs_changed[i].innerHTML="";  // flush the bullet
  },

  instrLoad: function(w){
    // flush the changes
    sim.mkLine(w);

    w.currentAddress=w.regs[0];

    // read/fetch instruction memory
    w.instrLen=2;
    //get first half :
    var a= 0xCD15; // limited to 16 bits at once

    if (a&1) {
      w.instrLen=4;
      a|= (w.cycle << 16);
    }

    w.currentInstruction=a;

    if (!profiles[w.profileName].valid[a&252]){ // 63<<2
      w.state=5; // FAULT
      sim.showState(w);
      w.BPstop=true;
    }
  },

  updateASM:function(w){
    var a=w.currentInstruction;
      w.Disas_hex.innerHTML=int2hex(a);
      w.Disas_msg.innerHTML="";

    if (profiles[w.profileName].valid[a&252]){ // 63<<2
      // disassemble the word
      Y.DISASM(a,w.DISASM);
      w.Disas_out.innerHTML=w.DISASM.instruction;
    }
    else{
      w.Disas_out.style.backgroundColor="orange";
      w.Disas_out.innerHTML="invalid";
    }
  },

  oneStep: function(w) {
    // read operands

    // execute


    // write operands (if condition true)

    // read/write data memory

    // display trace
    sim.logLine(w);

    // check cycle breakpoints
    w.cycle_id.innerHTML
      =++w.cycle;

    // writeback PC (if not already modified)
    // check address breakpoints => incorporated in PC writeback
// if... == " "
    sim.regWrite(w,0,w.instrLen+w.currentAddress); // This write will not trigger the "change" flag because it is reset just after

    sim.instrLoad(w);
  },

  stop:function(w){
    if (w.state<3) // INIT STEP or RUN (don't let HALT or FAULT restart the whole thing)
      w.state=3;// "STOP"
    sim.showState(w);
    sim.updateASM(w);
  },

  buttonStop:function(e,t) {
    sim.stop(parentWin(t||this));
  },

  buttonStep: function(e,t) {
    var w=parentWin(t||this);
    sim.stop(w);
    sim.oneStep(w);
    sim.updateASM(w);
  },

// TO BE REPLACED
  multiStep: function(w){
    if(w.state<3){
      var i=w.skipCycles;
      while (i--) {
        sim.oneStep(w);
        if (w.BPstop)
          return sim.stop(w); // does sim.updateASM(w); too
      }
      if (w.state==2) // "RUN" => restart later
        redraw( function(){ // Closure
           sim.multiStep(w);
        });
      sim.updateASM(w);
    }
  },

////////// VERY WRONG !!!! the different sims should have a central "dispatcher" so they are synchronised !

  buttonMultiStep: function(e,t) {
    var w=parentWin(t||this);
    sim.stop(w);
    if (w.state<4) {
      w.state=1;// "STEP"
      sim.multiStep(w);
      sim.stop(w);
    }
  },

  buttonRun: function(e,t) {
    var w=parentWin(t||this);
    sim.stop(w);
    if (w.state<4){
      // re-run
      w.state=2;// "RUN"
      sim.showState(w);
      sim.multiStep(w);
    }
  },


///////////// Profiles :
  change_profile: function(a,w) {
    if(typeof a!="string"){
      // when called from changing the selector
      var t=this;
      if(w)
        t=w.ProfileSel;
      else
        w=parentWin(t);
      a=t.options[t.selectedIndex].text;
    }
    else {
      var found=false;
      if (typeof profiles[a]!="object")
        return Al8N("Ipn");
      var i,sel=w.ProfileSel;
      for (i in sel.options) {
        if (sel.options[i].text==a) {
          found=true;
          break;
        }
      }
      if (!found) {
        // new profile added by the user since last click ?
        i=sel.options.length;
        sel.options[i]=new Option(a);        
      }
      sel.selectedIndex=i;
    }
    w.profileName=a;

    var m=0, b=profiles[a].datapath;
    if (w.bpBits != a) {
      w.DISASM.YASEP_TYPE
        =w.bpBits
        =b;
      while (b--)  // iterative mask creation because
        m+=m+1;    // 1<<32 == 1 !!! (5 LSB kept)
      w.bpMask=m;

      // check all the inputs under w.BPdiv, in case they are now out of range
      var l=w.BPdiv.getElementsByTagName("INPUT");
      for (b in l)
        if (l[b].id=="num")
            l[b].onkeyup();

//    update/redraw register values with new mask
      sim.redisReg(w);

//  this could change the cursor position in YASMed !
    }
  },

  update_proflist:function(u,t) {
    t=t||this;
    var p,s=t.selectedIndex,i=0;

    for (p in profiles) {
      // the position is reset to 0 each time the list is changed,
      // which makes some weird visual inconsistencies,
      // so update only if really needed (but does not really solve the "bug")
      // listBlur helps too.
      if (!t.options[i] || (t.options[i].text!=p))
        t.options[i]=new Option(p);
      i++;
    }
    t.selectedIndex=s>0?s:0; // by default s is -1 ?...
  },

  listBlur:function(){ // prevents a visual bug...
    var w=parentWin(this);
    sim.change_profile(w.profileName,w);
  },


/////////////// Radix
  chBase: function(t){
    var i, w=parentWin(t);
    w.num_func=sim["num_"+t.value];
    sim.redisReg(w);
  },

  num_bin: function(n,d){
    return toBin(n,d,1)+"b";
  },

  num_dec: function(n){
    return n;
  },

  num_hex: function(n){
    return int2hex(n);
  },

  redisReg: function(w){
    var r;
    for (i in w.regs){
      r=w.regs[i];
      w.regs_id[i].innerHTML=
         r!==null ? w.num_func(w.regs[i] & w.bpMask, w.bpBits) : "u";
    }
  },

/////////////// Register history

  displayRegHistory: function(n,w){
    if (!w){
      n=this.nr;
      w=parentWin(this);
    }
    w.regName.innerHTML=Y.registers_names[n];
//       win.HistoDiv
  },
/*
  createRegHistory: function(nr,nm){
// <u>History of Register :</u>
  },
*/

////////////// Register write
  regWrite: function(w,r,v, sym) {

    r&=15; // check that r >= 0 and <16
    v&=w.bpMask; // check that value >= 0 and <= bitMask
    if (!r) {   // The LSB of the PC is always 0:
      if (v&1)
        sim.traceLog("attempt to write to PC's LSB");
      v&= ~1;
    }

    // if equal, don't log ?
    if(w.regs[r]!=v){

      // update the register value in w.regs
      w.regs[r]=v;

      // display the value
      w.regs_id[r].innerHTML=w.num_func(v,w.bpBits);

      // Change the background color if it's a A register that is parked
      if ((r>6)&&(r&1)) // A register ?
/*     { // compute the parking address
        var p=r>>1, b="";
        if (v== p|(w.bpMask&~7))
          b="P";
        w.regs_id[r].id=b;
      } */
        w.regs_id[r].id= (v==((w.bpMask&~7)|(r>>1))) ?"P":"";

      //toggle the "changed" flag
      w.regMod[r+r+1]
        =w.regs_changed[r].innerHTML
        =sym||"\u25CF";

      // update the trace log

      // scan the breakpoint list

    }
  },

  checkRegister:function(t){
    if(t.value=="u")
       t.value=0;
    var  n
      =sim.numval
      =str2int(t.value),
    w=sim.pw||(sim.pw=parentWin(edit_text.current_elem)),
    m=w.bpMask+1;
    edit_text.valid=!((n===null)||(n>=m)||(n<(m/-2)));
  },

  validRegister:function(t){ // normally, the sim.numval is correct because save is turned on when valid==true
    sim.regWrite(sim.pw, t.rn, sim.numval,"\u25C6");

    // erase source so innerHTML will be re-read next time after update by sim
    t.source
      =sim.pw
      =null;
  },
/*
////////////// Carry & Zero
///          e.onchange=sim["click"+name];
///          td.onclick=sim["display"+name];

  changeCarry:function(v) {
  },

  changeZero:function(v) {
  },

  clickCarry:function(v) {
  },

  clickZero:function(v) {
  },

  displayCarry: function(n,w){
  },

  displayZero: function(n,w){
  },
*/

/////////////// breakpoints (low level API)
/*
 // TODO : detect duplicate breakpoints

  addBr_cycle:function(w,cycle) {
  },

  addBr_addr:function(w,addr) {
  },

  addBr_valReg:function(w,val,reg) { // passe la valeur en négatif
  },

  toggleBr:function(w,br) { // passe la valeur en positif / négatif
  },

  deleteBr:function(w,br) {
  },

  changeBPval:function(w,br,val) {
  },

  changeBPreg:function(w,br,reg) {
  },
*/
/////////////// breakpoints display / interface

  addNewBP:function(d){
//    v.stopPropagation();
    var e,f;
    (e=dcE("DIV")).className="BPitem";
     e.id="off";

       f=dcE("DIV");
       f.className="minus";
       f.onclick=sim.deleteBP;
       f.title="delete this breakpoint";
     e.appendChild(f);

       f=dcE("INPUT");
       f.type="checkbox";
       f.title="enable/disable this breakpoint";
       f.onchange=sim.click_toggleBr;
     e.active_id=f;
     e.appendChild(f);

    d.appendChild(e);

    //    d.style.display="block"; replaced by selective clicking:
    if(d.style.display!="block")
      d.previousSibling.spanShow.onclick();

    d.total_id.innerHTML= ++d.total;
    return e;
  },

  checkNumber: function(ev){
    var t=this,
      d=t.parentNode,
      w=parentWin(d),
      m=w.bpMask+1,
      n=str2int(t.value);
      a=d.active_id;
    // disables the breakpoint
    if(a.checked){
       a.checked=false;
       a.onchange();
     // note : it can be de-checked only if it was checked before,
     // meaning that t.parentNode.number was != null
     // so click_toggleBr executes the correct branch
     // (even when we just cleared the box)
    }
    if ((n===null)||(n>=m)||(n<(m/-2))) {
      n=null;
      t.style.backgroundColor="#F65";
    }
    else
      t.style.backgroundColor="";
    t.parentNode.number=n;
  },

  addNumberField:function(){
    var e=dcE("INPUT");
    e.id="num";
    edit_text.register(e, {
      size:10, maxsize:33,
      defaultValue: "0",
      func:sim.checkNumber
    });
    return e;
  },

  deleteBP:function(e,t){
    t=(t||this);
    var u=t.parentNode, // the breakpoint div
        d=u.parentNode; // container div
    d.total_id.innerHTML= --d.total;
    if (t.nextSibling.checked)
      d.active_id.innerHTML= --d.active;
    d.removeChild(u);
  },

  click_addBr_cycle:function(e,t) {
    var w=parentWin(t||this),
        i=w.BPcycle_id,
        d,f;
    d=sim.addNewBP(i);
    d.appendChild(sim.addNumberField());
  },

  click_addBr_addr:function(e,t) {
    var w=parentWin(t||this),
        i=w.BPaddr_id,
        d,f;
    d=sim.addNewBP(i);
    d.appendChild(sim.addNumberField());
  },

  click_addBr_valReg:function(e,t) { // passe la valeur en négatif
    var w=parentWin(t||this),
        i=w.BPvalReg_id,
        d,s;
    d=sim.addNewBP(i);

    d.appendChild(s=sim.regSel.cloneNode(true));
    s.selectedIndex=1;
    d.appendChild(s=sim.relSel.cloneNode(true));
    s.selectedIndex=2;
    d.appendChild(sim.addNumberField());
  },

  click_toggleBr:function(e,t) { // passe la valeur en positif
    t=t||this;
    var p=t.parentNode,
        d=p.parentNode;
    if(p.number!==null){ // 
      d.active_id.innerHTML // houba !
        =(d.active+= t.checked?1:-1);
/*
      if (t.checked){
// activate the proper BP with the new value

      }
      else{
// disables
      }
*/
    }
    else // trying to click when invalid?
      t.checked=false; // force the checkbox back
  },
/*
  click_deleteBr:function(e,t) {
    t=t||this;
  },
*/

//////////////////////////////////////////////////////////////////////////////////////////
// trace

  resetTrace:function(w){
    sim.mkLine(w);
    w.trace_id.innerHTML=""; // ZZZZzzzzapppp!
    w.traceLen=0;
    w.logBuff="";
  },

  mkLine:function(w){
    if (!w.regMod)
      w.regMod=[];
    for (var i=0;i<32;i++)
      w.regMod[i]=" ";
  },

  traceLog:function(w, msg){
    w.logBuff+="\n"+msg;
  },

  logLine:function(w){
    var i=w.traceLen+1,
     j=w.currentInstruction & 252,
     o=Y.opcode_table[j],
     f=dcE("DIV");
     f.innerHTML=pad_left(w.cycle,9)
         +pad_left(w.currentAddress,11) //" 4294967296"
         +pad_left(o?o.name:("("+j+")"),6)
         +"  ● ▴ ▴ ● ▴ ▴ ▴       ▴ ▴ ▴ ❇ ▴ ▴ c Z 4294967296 "+w.logBuff;
    w.logBuff="";
    w.trace_id.appendChild(f);
    w.trace_id.scrollTop=w.trace_id.scrollHeight;
    // flush oldest traces
    while(i>w.traceMax){
      w.trace_id.removeChild(w.trace_id.firstChild);
      i--;
    }
    w.traceLen=i;
  },

  log:function(w,msg){
    w.shortmsg(msg);

  },

// for changing the trace depth :
  checkTraceMax:function(t){
    var  n
      =sim.numval
      =str2int(t.value);
    edit_text.valid=((n!==null)&&(n>=0));
  },

  validTraceMax:function(t){ // normally, the sim.numval is correct because save is turned on when valid==true
    parentWin(edit_text.current_elem).traceMax = sim.numval;
    // erase source so innerHTML will be re-read next time after update by sim
    t.source=null;
    // flush excedent : in logLine
  },

/*
operand Read: \u25B4 ▴
result write: \u25CF ● 
implicit memory write : \u2747 ❇    

0 => condition register cleared
o => not 0
L => LSB=1
l => LSB=0
M => MSB=1
m => MSB=0
c/C => carry
z/Z => Zero
user write : ◆ \u25C6

*/

//////////////////////////////////////////////////////////////////////////////////////////
/*
// Read the memory

  readMem:function(w,addr){
  },

  writeMem:function(w, addr, val){
  },
*/
//////////////////////////////////////////////////////////////////////////////////////////
/////////////// Building a window
  start: function() {
    var cont=dcE("DIV"),
      w = ygwm.new_window(
         "YASim "+sim.simCount, null, cont,
         550, 650, 130, 100, false, true, true, true, false, "ms2_yelo"),
      c, d, f, i, p, tt,tb,tr,td, sel=dcE("SELECT");

//    w.bpMask=F4;  set at the end by a call to change_profile
//    w.bpBits=16;

    w.eraseCallback=sim.stop; // In case we close the window during a simulation run

       (d=dcE("DIV")).innerHTML='<font color="red">'+WARN+'WORK IN PROGRESS</font>';
    cont.appendChild(d);

/////// Top :

    function h3(n,u,k){
        (f=dcE("DIV")).className="simTitle";

          var g=dcE("SPAN");
          g.innerHTML='<span>\u25BD</span>&nbsp;'+I8N(n);
          g.style.cursor="pointer";
          g.onclick=sim.showhideNext;
          g.title="click to show/hide";
        f.appendChild(g);

      cont.appendChild(f);
      d.style.clear="both";
      cont.appendChild(d); // YES, d must be created BEFORE calling h3 and the code looks reversed
      if (u)
        adjustHeight(u,k);
    }

    (e=dcE("DIV")).className="tagArea";
     e.title="Drag&Drop the arrow to the YASMed line\nwhere you want to execute code";
     e.appendChild(sim.create_cursor("red",sim.simCount,null));

    cont.appendChild(e);

    function button(c,f,t){
      (e=dcE("BUTTON")).innerHTML=c;
      e.onclick=f;
      if(t)
        e.title=t;
      d.appendChild(e);
    }

    w.state=sim.INIT;
      d=dcE("DIV");
      button("\u21E4",sim.resetState,"Reset"); //x21E4 ⇤ reset
      button("\u25B6",sim.buttonRun,"Run");         //x25B6 ▶  run
//      button("\u25ae\u25ae",sim.buttonStop,"Pause"); //x25ae ▮  X2 =>pause
      button("\u25FC",sim.buttonStop,"Stop");        //x25FC ◼ stop
// others :
//x21BB ↻ ? redo ?
//x21FB  ⇻ ?
//x2933  ⤳  skip over function calls
      button("\u21B7",sim.buttonStep,"Step");        //x21B7 ↷ step
      button("\u21B7\u21B7\u21B7",sim.buttonMultiStep,"Step X cycles");

      (e=dcE("SPAN")).innerHTML="&nbsp;steps:";
      d.appendChild(e);
      d.appendChild(e=dcE("INPUT"));
      edit_text.register(e, {
        size:4, maxsize:4,
        defaultValue: "10",
        func: function(ev){
          var t=this;
          edit_text.filter_number(t);
          var n=str2int(t.value);
          if (n<2)
              n=2;
          parentWin(t).skipCycles
            =t.value
            =n;
        }});
    w.skipCycles=10;

      (e=dcE("SPAN")).innerHTML="&nbsp;Cycle&nbsp;#";
      d.appendChild(e);
/*      (e=w.cycle_id
        =dcE("SPAN")).innerHTML
            =w.cycle   // Set in the reset function
            =0;*/
      d.appendChild(w.cycle_id=dcE("SPAN"));


//    sim.showState(w);   ///////////////////////////////:
    cont.appendChild(d);

/// Disassembler
      (e=dcE("DIV")).innerHTML='Instruction:&nbsp;<span id="hex">u</span>=<a style="cursor:pointer" class="asm_active" id="disas" onclick="wa(\'ASM/asm#a?\'+this.innerHTML)"> </a> &nbsp; <span id="msg"></span>';
      (w.Disas_div=e).style.margin="2px";
    d.appendChild(e);
     w.Disas_out=getById("disas","A",e);
     w.Disas_hex=getById("hex","SPAN",e);
     w.Disas_msg=getById("msg","SPAN",e);

    w.DISASM= new Y.DISASM_context(function(col,msg){ // closure, but can't avoid it simply
      if(col!="blue"){
        w.Disas_out.style.backgroundColor=col;
        w.Disas_msg.innerHTML=msg;
      }
    });


/////// Configuration

      (d=dcE("DIV")).innerHTML=I8N("prf")+":&nbsp;";
        // profile selector
        sel.onblur=sim.listBlur;
      d.appendChild(
        w.ProfileSel=sel);
/*
// source :
        (e=dcE("DIV")).innerHTML="Source : ☑JS <strike>GHDL</strike> <strike>YCD</strike>";
      d.appendChild(e);

 // JS: selecteur de YASMed
 // GHDL
 // YCD

// import/export config
*/

    h3("cnf");


/////// Registers

    w.regs_changed=[];
    w.regs=[];
    w.regs_id=[];
      (tt=dcE("TABLE")).style.fontFamily="monospace";
       tt.style.textAlign="right";
       tt.style.borderSpacing="0px";
       tt.appendChild(tb
         =dcE("TBODY"));
       c='<th onclick="sim.flushChanges(0,this)" title="'+
           "flush the flags"
         +'"style="cursor:pointer">\u2260</th><th>Reg</th><th>&nbsp;Value&nbsp;</th><th>&nbsp;</th>';
       (tr=dcE("TR")).innerHTML=c+c
          +'<td id="histoReg" rowspan="18" style="padding:5px; border:1px solid #999; text-align:left; overflow: auto;'
          +'vertical-align:top"><u>History&nbsp;of&nbsp;<span id="regName"></span>:</u><div id="HistoDiv">cycle:adresse:valeur</td>';
       tb.appendChild(tr);
       w.regName=getById("regName","SPAN",tr);
       w.HistoDiv=getById("HistoDiv","SPAN",tr);
       sim.displayRegHistory(0,w);

       for (i in Y.registers_names){
         w.regs[i]=null;
         c=Y.registers_names[i];

////       w.XXX = sim.createRegHistory(i,c);
         if(!(+i & 1))
           tr=dcE("TR");

           (td=dcE("TD")).className=c[0];
         tr.appendChild(
              w.regs_changed[i]=td);

           (td=dcE("TD")).className=c[0];
           td.innerHTML=c+":";
           td.title="Click to view the last values";
           td.style.cursor="pointer";
           td.nr=+i; //passes the argument through "this"
           td.onclick=sim.displayRegHistory;
           td.style.padding="1px";
         tr.appendChild(td);

           (td
             =w.regs_id[i]
             =dcE("TD")).className=c[0];
//           td.innerHTML="u"; // change_profile calls redisReg  will be removed soon thanks to initialisation
           edit_text.register(td, {
             size:10, maxsize:33,
             defaultValue: "0",
             check: sim.checkRegister,
             func:  sim.validRegister
           });
           td.rn=i; // used later so the proper register gets written
         tr.appendChild(td);

         tr.appendChild(dcE("TD"));

         if(+i & 1)
           tb.appendChild(tr);
       };

      function flag(name){
        tr.appendChild(dcE("TD"));
           (td=dcE("TD")).colSpan=2;
          td.innerHTML=name+":";
          (e=dcE("INPUT")).type="checkbox";
          e.onchange=sim["click"+name];
          td.onclick=sim["display"+name];
          td.style.cursor="pointer";
          td.appendChild(
             w[name+"_id"]=e);
        tr.appendChild(td);
        tr.appendChild(dcE("TD"));
      }

      tr=dcE("TR");
        flag("Carry");
        flag("Zero");
      tb.appendChild(tr);

      (d=dcE("DIV")).appendChild(tt);

      d.appendChild(e=dcE("FORM"));
        e.style.fontSize="70%";
        f='<input type="radio" name="rb" onclick="sim.chBase(this)" value=';
        e.innerHTML=I8N("rdx")
           +f+'"bin"/> bin &nbsp;'
           +f+'"dec"/> dec &nbsp;'
           +f+'"hex" checked="checked"/> hex &nbsp;';
    h3("rgs",d);
    w.num_func=sim.num_hex;

/////// Breakpoints
      function newBP(text,fun,i){
        (f=dcE("DIV")).className="simBP";
        var g=dcE("DIV");
           g.onclick=fun;
           g.className="plus";
           g.title="Create a new breakpoint";
         f.appendChild(g);

          (g=dcE("SPAN")).innerHTML='<span>\u25BD</span>&nbsp;<i>(<span id="active"></span>/<span id="total"></span>)</i>&nbsp; '+text;
           g.onclick=sim.showhideNext;
           g.title="click to show/hide";
           g.style.cursor="pointer";
           f.spanShow=g; ////!!!
         f.appendChild(g);

        d.appendChild(f);
        d.appendChild(g
           =w[i]
           =dcE("DIV")); // The sub-div
         g.style.display="block";
         (g.active_id=getById("active","SPAN",f)).innerHTML=g.active
        =(g.total_id =getById("total" ,"SPAN",f)).innerHTML=g.total
           =0;
      }

      (w.BPdiv
        =d
        =dcE("DIV")).style.display
                         ="block";
        newBP("stop at cycle :",sim.click_addBr_cycle,"BPcycle_id");                // blacklist(BPcycle_id)....
        newBP("stop at instruction address :",sim.click_addBr_addr,"BPaddr_id");
        newBP("stop on register write :",sim.click_addBr_valReg, "BPvalReg_id");
    h3("brk",d);

////////////////// Trace

       (d=dcE("DIV")).style.fontFamily="monospace";
    // The fixed header
       d.style.whiteSpace="pre";
         f='<span style="background-color:#';
         i='</span>';
     (e=dcE("DIV")).innerHTML
=' trace depth:<span id="traceMax">100</span>          '
+'<span style="cursor:pointer;background-color:#DFD" onclick="toggle(this.nextSibling)"'
+' title="show/hide the meaning of the symbols">Legend</span><div style="display:none;border:2px solid #dedefa">'
+' Left: read                   Right: write\n'
+'    \u25B4  Operand read           \u25CF  Result write\n'
+'  0,o  read cond. Zero        \u2747  Implicit (memory) write\n'
+'  L,l  read cond. LSB         \u25C6  Manual write\n'
+'  M,m  read cond. MSB'
+'</div>'
+'\n    cycle    address  opc  PC'
+f+'A0A0D0">R1R2R3R4R5'+i
+f+'D0A0A0">D1D2D3D4D5'+i
+f+'A0D0A0">A1A2A3A4A5'+i+' C Z   value';
    d.appendChild(e);
    w.traceMax=100;
    (f=getById("traceMax","SPAN",d)).title="Change how many cycles\nare held in memory";
    edit_text.register(f, {
        size:5, maxsize:5,
        defaultValue: "100",
        check: sim.checkTraceMax,
        func:  sim.validTraceMax
    });

     // The scrolling contents
        f =w.trace_id
          =dcE("DIV");
      d.appendChild(f);
    h3("trc", w.trace_id,100);
    sim.resetTrace(w);

///////////////////////////////////////////////
// Memory :

      (d=dcE("DIV")).innerHTML="(to be created soon)";
    h3("mem",d,40);

///////////////////////////////////////////////
// The end :
    cont.appendChild(dcE("HR"));

///////////////////////////////////////////////

    // done at the end so it updates the display
    (sel.onfocus=sim.update_proflist)(0,sel);
    (sel.onchange=sim.change_profile)(0,w); // calls sim.redisReg(w);
    sim.resetState(0,w);
    w.simCount=sim.simCount++;

///////////////////////////// ugly dev stuff here /////////////////////////////


////////// créer un breakpoint par programme ici :


//////////// send test signals :

/*
for (var i=0; i<150; i++)
  sim.logLine(w);

     (d=dcE("BUTTON")).innerHTML="add trace";
     d.onclick=function(){
       sim.logLine(w);
     };
   h3("ctl");

// this checks that arbitrary new profiles will update the selector
     (d=dcE("BUTTON")).innerHTML="flof";
     d.onclick=function(){
       sim.change_profile("flof",w);
     }
   h3("ctl");

  sel.disabled=true;// when using an external core
  sim.change_profile("microYASEP",w);

  sim.updateASM(w); // hide
  sim.updateASM(w,0x84); // triggers an error
  sim.updateASM(w,123456789); // disassemble

  sim.regWrite(w,3,42);
  sim.regWrite(w,4,3456);
  sim.regWrite(w,7,12345678);

  sim.regWrite(w,-7,-5); // parking
  sim.regWrite(w,-5,-3); // parking
  sim.regWrite(w,-3,-4); // parking
  sim.regWrite(w,-1,-1); // parking
sim.updateASM(w,123456789); // disassemble
*/

    return w;
  },

  init_obj: function(){
    var i,
      r="any less equal more different".split(" ");

    for (i in sim.states)
      sim[sim.states[i]]=i;

    sim.regSel=dcE("SELECT");
    for (i in Y.registers_names)
      sim.regSel.options[i]=new Option(Y.registers_names[i]);

    sim.relSel=dcE("SELECT");
    for (i in r)
      sim.relSel.options[i]=new Option(r[i]);
 
    menu.subMenuItem(menu.list["Tools"],i8n.sim, "tool/YASim");
  }

});
